[oe-commits] Jeremy Lainé : udev: add boc01-specific mount. sh script

GIT User account git at amethyst.openembedded.net
Mon Dec 22 14:53:41 UTC 2008


Module: openembedded.git
Branch: org.openembedded.dev
Commit: bef2c879b9e48090bd2e70b1e88b81aa9a7adf63
URL:    http://gitweb.openembedded.net/?p=openembedded.git&a=commit;h=bef2c879b9e48090bd2e70b1e88b81aa9a7adf63

Author: Jeremy Lainé <jeremy.laine at m4x.org>
Date:   Mon Dec 22 15:51:27 2008 +0100

udev: add boc01-specific mount.sh script

---

 packages/udev/files/boc01/mount.sh |   73 ++++++++++++++++++++++++++++++++++++
 packages/udev/udev_124.bb          |    2 +-
 2 files changed, 74 insertions(+), 1 deletions(-)

diff --git a/packages/udev/files/boc01/mount.sh b/packages/udev/files/boc01/mount.sh
new file mode 100644
index 0000000..07d2fd2
--- /dev/null
+++ b/packages/udev/files/boc01/mount.sh
@@ -0,0 +1,73 @@
+#!/bin/sh
+#
+# Called from udev
+# Attemp to mount any added block devices 
+# and remove any removed devices
+#
+
+MOUNT="/bin/mount"
+PMOUNT="/usr/bin/pmount"
+UMOUNT="/bin/umount"
+name="`basename "$DEVNAME"`"
+
+for line in `cat /etc/udev/mount.blacklist | grep -v ^#`
+do
+	if ( echo "$DEVNAME" | grep -q "$line" )
+	then
+		logger "udev/mount.sh" "[$DEVNAME] is blacklisted, ignoring"
+		exit 0
+	fi
+done
+
+automount() {	
+	! test -d "/media/$name" && mkdir -p "/media/$name"
+	
+	if ! $MOUNT -t auto -o ro $DEVNAME "/media/$name"
+	then
+		#logger "mount.sh/automount" "$MOUNT -t auto $DEVNAME \"/media/$name\" failed!"
+		rm_dir "/media/$name"
+	else
+		logger "mount.sh/automount" "Auto-mount of [/media/$name] successful"
+		touch "/tmp/.automount-$name"
+		boc-script scripts:photos.js "/media/$name"
+	fi
+}
+	
+rm_dir() {
+	# We do not want to rm -r populated directories
+	if test "`find "$1" | wc -l | tr -d " "`" -lt 2 -a -d "$1"
+	then
+		! test -z "$1" && rm -r "$1"
+	else
+		logger "mount.sh/automount" "Not removing non-empty directory [$1]"
+	fi
+}
+
+if [ "$ACTION" = "add" ] && [ -n "$DEVNAME" ]; then
+	if [ -x "$PMOUNT" ]; then
+		$PMOUNT $DEVNAME 2> /dev/null
+	elif [ -x $MOUNT ]; then
+    		$MOUNT $DEVNAME 2> /dev/null
+	fi
+	
+	# If the device isn't mounted at this point, it isn't configured in fstab
+	# 20061107: Small correction: The rootfs partition may be called just "rootfs" and not by
+	# 	    its true device name so this would break. If the rootfs is mounted on two places
+	#	    during boot, it confuses the heck out of fsck. So Im auto-adding the root-partition
+	#	    to /etc/udev/mount.blacklist via postinst 
+
+	cat /proc/mounts | awk '{print $1}' | grep -q "^$DEVNAME$" || automount 
+	
+fi
+
+
+
+if [ "$ACTION" = "remove" ] && [ -x "$UMOUNT" ] && [ -n "$DEVNAME" ]; then
+	for mnt in `cat /proc/mounts | grep "$DEVNAME" | cut -f 2 -d " " `
+	do
+		$UMOUNT $mnt
+	done
+	
+	# Remove empty directories from auto-mounter
+	test -e "/tmp/.automount-$name" && rm_dir "/media/$name"
+fi
diff --git a/packages/udev/udev_124.bb b/packages/udev/udev_124.bb
index 629a7ae..9b64bdc 100644
--- a/packages/udev/udev_124.bb
+++ b/packages/udev/udev_124.bb
@@ -3,7 +3,7 @@ DESCRIPTION = "udev is a daemon which dynamically creates and removes device nod
 the hotplug package and requires a kernel not older than 2.6.12."
 RPROVIDES_${PN} = "hotplug"
 
-PR = "r9"
+PR = "r10"
 
 SRC_URI = "http://kernel.org/pub/linux/utils/kernel/hotplug/udev-${PV}.tar.gz \
 	   file://noasmlinkage.patch;patch=1 \





More information about the Openembedded-commits mailing list